#include "histogram.h"

using namespace std;

void
find_minmax(const vector<double>& numbers, double& min, double& max, bool& empty_vector)
{
    if (numbers.empty())
    {
        empty_vector = true;
    }
    else
    {
        min = numbers[0];
        max = numbers[0];
        for (double x : numbers)
        {
            if (x > max )
            {
                max = x;
            }
            if (x < min)
            {
                min = x;
            }
        }
    }
}

vector<size_t>
make_histogram(const vector<double>& numbers, size_t& bin_count)
{
    double min, max;
    bool empty_vector = false;
    find_minmax(numbers, min, max, empty_vector);


    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count);

    if (empty_vector)
    {
        for (size_t y : bins)
        {
            y = 0;
        }
    }


    for (size_t i = 0; i < numbers.size(); i++)
    {
        for (size_t j = i + 1; j < numbers.size(); j++)
        {
            if (numbers[i] == numbers[j])
            {
                //numbers.erase(numbers.begin() + j);
                //number_count--;
                //i--;
                //cout << "Removed number " << numbers[j] << endl;
            }
        }
    }

    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
                auto low_bound = min + j * bin_size;
                auto high_bound = min + (j + 1) * bin_size;
                if ((low_bound <= numbers[i]) && (numbers[i] < high_bound))
                {
                    bins[j]++;
                    found = true;
                }
        }

        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }

    return bins;
}
